/*
 * ACB-BF592 MDMAgpRs[R[h
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 */

#include <blackfin.h>
#include <builtins.h>
#include <string.h>

/* VXeNbN(100MHz) */
#define SCLOCK_HZ		(100000000)

/* MDMAɎgpobt@ */
static uint8_t sf_memcpy_src[1024];
static uint8_t sf_memcpy_dst[1024];

static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

static void s_mdma_memcpy(void* p_dst, const void *p_src, uint16_t size)
{
    /* MDMA_S0WX^ɃRs[̐ݒ肷 */
    *pMDMA_S0_CONFIG     = FLOW_STOP | WDSIZE_8;
    *pMDMA_S0_IRQ_STATUS = DMA_DONE | DMA_ERR;
    *pMDMA_S0_START_ADDR = (void*)((uint32_t)p_src); /* const void* => void*ϊ */
    *pMDMA_S0_X_COUNT    = size;
    *pMDMA_S0_X_MODIFY   = 1;

    /* MDMA_D0WX^ɃRs[̐ݒ肷 */
    *pMDMA_D0_CONFIG     = FLOW_STOP | DI_EN | WDSIZE_8 | WNR;
    *pMDMA_D0_IRQ_STATUS = DMA_DONE | DMA_ERR;
    *pMDMA_D0_START_ADDR = p_dst;
    *pMDMA_D0_X_COUNT    = size;
    *pMDMA_D0_X_MODIFY   = 1;
    ssync();

    /* DMAN */
    *pMDMA_S0_CONFIG    |= DMAEN;
    *pMDMA_D0_CONFIG    |= DMAEN;
}

static int32_t s_mdma_memcpy_done(void)
{
    uint16_t l_dma_status;
    int32_t  l_rv = 1; /* 1 = DMA busy */

    /* MDMA_D0_IRQ_STATUS̒lRs[ */
    l_dma_status = *pMDMA_D0_IRQ_STATUS;
    if((l_dma_status & (DMA_DONE | DMA_ERR)) != 0u)
    {
        /* MDMA𖳌ɐݒ */
        *pMDMA_S0_CONFIG = 0u;
        *pMDMA_D0_CONFIG = 0u;
	    *pMDMA_S0_IRQ_STATUS = DMA_DONE | DMA_ERR;

        if((l_dma_status & DMA_ERR) == 0u)
        {
        	/* MDMA */
        	l_rv = 0;
        }
        else
        {
        	/* MDMAG[ */
        	l_rv = -1;
        }
    }

    return l_rv;
}

void main(void)
{
	uint32_t l_lc;
	int32_t  l_result;
	
	/* PLLݒ */
	s_bfin_clk_pll_set(16, 4);
	
	/* Rs[Ƀ_~[f[^ݒ */
	for(l_lc = 0u; l_lc < sizeof(sf_memcpy_src); l_lc++)
	{
		sf_memcpy_src[l_lc] = (uint8_t)(l_lc);
	}
	/* Rs[[NA */
	memset(sf_memcpy_dst, 0, sizeof(sf_memcpy_dst));

	/* Rs[ */
	s_mdma_memcpy(sf_memcpy_dst, sf_memcpy_src, sizeof(sf_memcpy_src));
	
	/* Rs[I܂őҋ@ */
	while(s_mdma_memcpy_done() != 0) NOP();
	
	/* r */
	if(0 == memcmp(sf_memcpy_dst, sf_memcpy_src, sizeof(sf_memcpy_src)))
	{
		/*  */
		l_result = 0;
	}
	else
	{
		/* s */
		l_result = -1;
	}
}
